using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;

public class EnemyAI : MonoBehaviour
{
    private GameObject player;
    private LevelManager manager;

    void Start()
    {
        manager = FindObjectOfType<LevelManager>();
        player = FindObjectOfType<Shooting>().gameObject;
    }

    Vector3 GetDirection(Vector3 f, Vector3 s)
    {
        float x_move = s.x - f.x;
        float z_move = s.z - f.z;
        float m = Math.Abs(Math.Max(z_move, x_move));
        return new Vector3(x_move / m, 0f, z_move / m);
    }

    float GetDistance(Vector3 first, Vector3 second)
    {
        return (float)Math.Pow((Math.Pow(Math.Abs(first.x - second.x), 2f) + Math.Pow(Math.Abs(first.z - second.z), 2f)), 0.5f);
    }

    void Update()
	{
		if (manager.gameStatus == "Playing")
        {
            Vector3 direction = player.transform.position - transform.position;
            direction -= new Vector3(0f, direction.y, 0f);
            transform.rotation = Quaternion.LookRotation(direction, new Vector3(0f, 1f, 0f));

            if (GetDistance(transform.position, player.transform.position) >= 1f)
                transform.position += GetDirection(transform.position, player.transform.position) * 0.2f * Time.deltaTime;
        }
	}
}
