using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class EnemyShooting : MonoBehaviour
{
    private GameObject player;
    private System.Random rand = new System.Random();
	private LevelManager manager;
	private Shooting shooter;

	private float shootedTimer = -1;

    float GetDistance(Vector3 first, Vector3 second)
    {
        return (float)Math.Pow((Math.Pow(Math.Abs(first.x - second.x), 2f) + Math.Pow(Math.Abs(first.z - second.z), 2f)), 0.5f);
    }

    void Start()
	{
		manager = FindObjectOfType<LevelManager>();
        shooter = FindObjectOfType<Shooting>();
        player = shooter.gameObject;
    }
	
	void Update()
	{
		if (rand.Next(0, 300) == 0 & manager.gameStatus == "Playing")
		{
			audioSource.Play();
			shootedTimer = 0;
			if (rand.Next(0, (int)(GetDistance(transform.position, player.transform.position) / 2f)) == 0)
			{
				manager.gameStatus = "Failed";
				shooter.bulletsCount = 0;
            }
        }
		if (shootedTimer != -1)
		{
			transform.FindChild("Spot Light").gameObject.enabled = true;
			shootedTimer += Time.deltaTime;
			if (shootedTimer >= 0.1f)
			{
				shootedTimer = -1;
                transform.FindChild("Spot Light").gameObject.enabled = false;
            }
		}
		else
		{
            transform.FindChild("Spot Light").gameObject.enabled = false;
        }
	}
}
