using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text.RegularExpressions;

public class LevelManager : MonoBehaviour
{
    public string gameStatus = "Playing";
    public Text UIStatusText;

    public float timeRemaining = 30f;

    private int currentLevel;
    private Shooting bulletsManager;

    void Start()
	{
        bulletsManager = FindObjectOfType<Shooting>();
        currentLevel = Convert.ToInt32(Regex.Replace(SceneManager.loadedScene, @"[^\d]+", ""));
    }
	
	void Update()
	{

        switch (gameStatus)
        {
            case "Playing":
                {
                    PlayingStatusUpdate();
                    break;
                }
            case "Failed":
                {
                    FailedStatusUpdate();
                    break;
                }
            case "Complited":
                {
                    ComplitedStatusUpdate();
                    break;
                }
        }
	}

    void PlayingStatusUpdate()
    {
        timeRemaining -= Time.deltaTime;

        UIStatusText.text = "";
        if (FindObjectsOfType<Man>().Length == 0)
        {
            gameStatus = "Complited";
        }
        else
        {
            if (bulletsManager.bulletsCount == 0 | timeRemaining <= 0)
            {
                gameStatus = "Failed";
            }
        }
    }

    void FailedStatusUpdate()
    {
        UIStatusText.text = "Press to restart";
        if (FindObjectsOfType<Man>().Length == 0 & !(timeRemaining <= 0))
        {
            gameStatus = "Complited";
        }
        if (Input.GetMouseButtonDown(0))
        {
            RestartLevel();
        }
    }

    void ComplitedStatusUpdate()
    {
        if (currentLevel != 10)
        {
            UIStatusText.text = "Press for next level";
            if (Input.GetMouseButtonDown(0))
            {
                MoveToNextLevel();
            }
        }
        else
        {
            UIStatusText.text = "Thanks for playing! Press esc to quit";
        }
    }

    void MoveToNextLevel()
	{
        SceneManager.LoadScene($"Scenes/{currentLevel+1}.scene");
    }

    void RestartLevel()
    {
        SceneManager.LoadScene($"Scenes/{currentLevel}.scene");
    }
}
