using FalcoEngine;

public class CameraController : MonoBehaviour
{
    public float sensivity = 1.0f;
    public bool lookX = true;
    public bool lookY = true;

    float rotationX = 0.0f;
    float rotationY = 0.0f;

    Quaternion originalRotation = Quaternion.identity;

    private Camera mainCamera;
    private bool aimed = false;

    void Start()
	{
        mainCamera = FindObjectOfType<Camera>();
        originalRotation = transform.localRotation;
    }

    void AimManager()
    {
        if (Input.GetMouseButtonDown(1))
        {
            if (aimed)
            {
                mainCamera.fov = 75f;
            }
            else
            {
                mainCamera.fov = 10f;
            }
            aimed = !aimed;
        }
    }

    void CameraRotation()
    {
        Vector2 mouse = Input.cursorDirection;

        if (lookX)
            rotationX += mouse.y * sensivity * 0.1f;

        if (lookY)
            rotationY -= mouse.x * sensivity * 0.1f;

        rotationX = ClampAngle(rotationX, -80.0f, 80.0f);
        rotationY = ClampAngle(rotationY, -360.0f, 360.0f);

        Quaternion yQuaternion = Quaternion.AngleAxis(rotationX, Vector3.right);
        Quaternion xQuaternion = Quaternion.AngleAxis(rotationY, Vector3.up);

        transform.localRotation = originalRotation * xQuaternion * yQuaternion;
    }

    public float ClampAngle(float angle, float min, float max)
    {
        angle = angle % 360;
        if ((angle >= -360F) && (angle <= 360F))
        {
            if (angle < -360F)
            {
                angle += 360F;
            }
            if (angle > 360F)
            {
                angle -= 360F;
            }
        }

        return Mathf.Clamp(angle, min, max);
    }

    void Update()
	{
        AimManager();
        CameraRotation();
    }
}
